/**********************************************************************
// added LCDWrite capability
* REVISION HISTORY:
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* Author    Tom kibalo        Date 2/20     Comments on this revision
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* MCHP              06/29/06  First release of source file
*
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* ADDITIONAL NOTES:
* modified for DSP30F2012 and no LCD display
**********************************************************************/

#include "p30fxxxx.h"
#include "delay.h"

/*=============================================================================
I/O INITIALISATION ROUTINE
=============================================================================*/
void initIo(void)
{

//configure port b to drive for output
		//rb3 = led
		TRISBbits.TRISB3=0;
		LATBbits.LATB3 =0;	//initialize to zero out
		//rd4 pulse digital out
		LATBbits.LATB4 =0;	//initialize to no led
		TRISBbits.TRISB4=0;  
		


// Make all the ANx pins as Digital Pins
//rb9 is analog in for caputre of pulse train
		ADPCFG=0xFDFF;			

}



/*=============================================================================
SWITCH ON LED3
=============================================================================*/

void swOnLED3(void)
{
	LATBbits.LATB3=1;
}
/*=============================================================================
SWITCH OFF LED3
=============================================================================*/

void swOffLED3(void)
{
	LATBbits.LATB3=0;
}


/*=============================================================================
TOGGLE LED3
=============================================================================*/
void tglLED3(void)
{
	LATBbits.LATB3^=1;
}
