/**********************************************************************
*  2006 Microchip Technology Inc.
*
* FileName:        main.c
* Dependencies:    Header (.h) files if applicable, see below
* Processor:       dsPIC24fj64ga002
* Compiler:        MPLAB C30 v2.02.00 or higher
*
* Running with Internal RC x 4PLL or 32Mhz -> 16MIPS
* REVISION HISTORY:
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* Author  Thomas Kibalo         Date   1/30/08   Comments on this revision
1/6/09		thk					three lines
1/7/09		buttons
1/21/09     added RTCC and Tbanner for HP16 demo -basic time displayfunction
1/24/09     added buttons
1/29/09     removed added backlight control RB13 toggles transistor BL ON/OFF, RB12  in button 5 
1/29/09		set for 2 line display
2/20/09     changes back to three line
2/21/09    developing demo splash screens for new experimenter board
2/22/09	   developing light show for pin 1-8 of expansion bus
2/23/09	   developing ADC for demo using channel 9 AN9 pin 26
2/24/09		developing demo button response
2/25/09		fixed button reponse and added clock
2/27/09		variable rate LED
3/1/09		attempting to make single push buttons for demos
3/19/09 added Demos for RGB
3/22/09 started loop for RGB to respond to buttons
3/23/09	fixed rgb presentation count
3/23/09 made RGB integral part of DEMo--replacing LED light show!
3/23/09	modified ADC to use AN4 to set stage for temperature sensor
10/23/09 constructed for Christmas issue
10/24/09 added tone
10/25/09  added single push button envoke of jingle bells


Button0 =RA0
Button1 =RA1
Button2 =RA2
Button3 =RA3

*/

//***************************************************/
// Include Header File
//***************************************************/

#include "p24fj64ga002.h"
#include "conU2.h"
#include "delay.h"
#include "lcd.h"
#include "rtcc.h"
#include "buttons.h"
#include "timer.h"
#include "adc.h"
#include "Demos.h"
#include "tone.h"

#include <math.h>

//***************************************************/
// Define Constants Variables
//***************************************************/

void fig_bit(unsigned char leds );
void lightdemo(control);
void RGB_Screen_Update( void);
void showRGB(void);
void showADC(void);
void checkButtons(void);
void clock (void);
void binary_to_ASCIIconvert( int n);
#define BUF_SIZE 32
#define max_led 128
static char	rxchar='0'; 
unsigned char light_pattern =0;
int adcvalue =0;
//demo flags
unsigned char AdcFlag =0;
unsigned char LightShowFlag =0;
unsigned char ClockFlag =0;
char bcd1000 =0;
char bcd100 =0;
char bcdtens =0;
char bcdunits =0; 
//int result;
char s[BUF_SIZE];
unsigned char got_rx =0;
//rgb color values and defines
#define red 0
#define green 1
#define blue 2
unsigned char red_value =0;
unsigned char blue_value =0;
unsigned char  green_value =0;
unsigned char color =0;
unsigned char color_screen_update =0;

char color_count[] ={ ' ',' ', ' ',' '};
//demo control flags
unsigned char lockAdc =0;
unsigned char lockLed =0;
unsigned char lockClock =0;
/// new contruct

const char christmas [] ={ 'e','-','-', 'e', '-' };

//char count[] = {'0','0','0','0',' ', ' ','0','.','0','V','d','c'};
char count[] = {' ',' ',' ',' '};  //modified to display temperature
int binary_temp =0;  //accumlated storage of temperature data
unsigned char z =0;	// temp accumlated count
//start of demo messages
//screen1
const	char screen1A[] =" Introducing the ";
const	char screen1B[] ="  16 Bit Micro   ";
const	char screen1C[] ="  Experimenter   ";
//screen2 
const	char screen2A[] ="A new Solderless ";
const	char screen2B[] ="    Breadboard   ";
const	char screen2C[] ="  Capability   ";
//screen3
const	char screen3A[] ="   Based upon   ";
const	char screen3B[] ="   Microchip's  ";
const	char screen3C[] =" PIC24FJ64GA002 ";				
//screen4
const	char screen4A[] =" 3.3 Vdc 16 MIPS ";
const	char screen4B[] ="64K Flash 8K RAM";
const	char screen4C[] ="   32K EEPROM   ";
//screen5
const	char screen5A[] =" Full 5V Logic ";
const	char screen5B[] ="  Interface    ";
const	char screen5C[] =" Compatibility ";
//screen6
const	char screen6A[] ="Perpherials:";
const	char screen6B[] ="ADC (2)SPI ";
const	char screen6C[] ="(2)UART (2)I2C";
//screen6A
const	char screen6AA[] ="Perpherials:";
const	char screen6AB[] ="clock calendar";
const	char screen6AC[] ="Capture/Compare";
//screen7
const	char screen7A[] ="Board features:";
const	char screen7B[] ="on board 3.3Vdc";
const	char screen7C[] =" supply        ";
//screen8
const	char screen8A[] ="Board features:";
const	char screen8B[] ="LCD Display 16x3";
const	char screen8C[] =" 4 pushbuttons ";
//screen9
const	char screen9A[] ="Board features:";
const	char screen9B[] ="ICSP Interface";
const	char screen9C[] ="program/debug ";
//screen10
const	char screen10A[] ="Board features:";
const	char screen10B[] ="Expansion Bus";
const	char screen10C[] =" 10 lines  ";
//screen11
const	char screen11A[] ="Vendor Supplied";
const	char screen11B[] =" experiments";
const	char screen11C[] =" demos";
//adc demo screen
//const	char screenADCA[] ="ADC Demo Output";
//const	char screenADCB[] ="count volts";
//modified for temperature sensor
const	char screenADCA[] ="Temperature";
const	char screenADCB[] ="Degrees F";
//I/O port demo
const   char screenIOA[]= " I/O Bus Demo";  //replace with RGB
const   char screenIOB[]= " Configured as";
const   char screenIOC[] = "8 LED display";
//variable rate demo
const   char screenVRA[]= " Var Rate Demo"; //not used
const   char screenVRB[]= " Turn pot to";
const   char screenVRC[] = "change LED's";
// RGB display
const   char screenRGB1[]= "Red =     ";
const   char screenRGB2[]= "Green=    ";
const   char screenRGB3[] ="Blue =    ";
//christmas
const char  H1[]=  "Merry Christmas";
const char H2[]=  "    and a";
const char H3[]= " Happy New Year!";
const char lyrics[] = "jingle bells,jingle bells,jingle all the way,oh what fun it is to ride, in a one horse , open sleigh -hey";
const char song1[] = "e--e---e----e-e---e----e--g--c--d----e----f---f------f--f-f-e--e--e-e--e---d----d-e-d--------g-";
const char song2[] = "e--e---e----e-e---e----e--g--c--d----e----f---f------f--f-f-e--e--e-e--g----g----f-d--c----";
//                |              |                |                |
const char J1[] = "jingle bells     jingle bells  ";
const char J2[] = "jingle           all the way! ";
const char J3[] = "oh what fun !    it is to ride! ";    
const char J4[] =  "in a one horse  open sleigh, ---hey!";
const char J5[] =  "in a one horse  open sleigh. ";
//transfer clock into subroutine
void clock (void) {
	//	LCDWrite(0x0F,0);
while (1) {
	if (TimerIsOverflowEvent()){
			// Button debounce processing
			QBtnProcessEvents();
		if (!TBannerIsSetup() && ClockFlag ==0) return;
			BtnProcessEvents();
				
//			// State dependent processing
//		
                // Show clock
			 TBannerProcessEvents();
//              
//	
		



	
//
////            // If S4 is pressed show the next example
			if (BtnIsPressed(4) ) {
                // Change field  
             
                   TBannerNext();

                // wait for button released
                while (BtnIsPressed(4))	BtnProcessEvents();

			}// End of 	if (BtnIsPressed(4)){...
//
//           
        		if (BtnIsPressed(1)){
                        TBannerSetup();
                    // wait for button released
                    while (BtnIsPressed(1))	BtnProcessEvents();
                }// End of if (BtnIsPressed(1 ...

                if(TBannerIsSetup()){
	           		if (BtnIsPressed(2)) {
                        TBannerChangeField(1);
                        // wait for button released
                        while (BtnIsPressed(2))	BtnProcessEvents();
    		    	}// End of if (BtnIsPressed(2)){...
    
	    		    if (BtnIsPressed(3)) {
                        // wait for button released
                        TBannerChangeField(0);
                        while (BtnIsPressed(3))	BtnProcessEvents();
        			}// End of if (BtnIsPressed(3)){...
                }// End of if(TBannerIsSetup( ...

//          
//
//            
//
    	}// End of if (TimerIsOverflowEvent()...
		
	
	
}	
	
	
}	

//enters a continuous loop until button S4 is depressed
// uses void RGB_Screen_Update( void) to update lCD--starts with RGB leds all turned down-no color
// S1 selects color, S2 decrement color , S3 increment Color, S4 exit
void showRGB (void) {
	
	 unsigned char address=0;
 	RGBTurnOnLED( 255,255,255); //255 is off, 0 is on
 
	 blue_value =255;
	 red_value =255;
	 green_value =255;
 	 RGBSetBlue( blue_value ); 
 	RGBSetGreen( green_value );
	 RGBSetRed(red_value);
	 
	 RGB_Screen_Update();
	 	move_FirstLine();
		color_count [3]= '<' ; // ascii <
   		address =0x80+10;
   		LCDWrite(address,0); //point to data field of red count
   		update_Display(color_count[3], 1);
	
 while(1) {
	if  (color_screen_update==1) 
	{
	 	RGBSetBlue( blue_value ); 
 		RGBSetGreen( green_value );
	 	RGBSetRed(red_value);
	 	RGB_Screen_Update();
		color_screen_update=0;	
	}	
	 if (TimerIsOverflowEvent()) {
		 	QBtnProcessEvents();
		 	if (BtnIsPressed(4) ) return; //exit
		 if (BtnIsPressed(1) ) {
		 	color++;
		 	color_screen_update=1;
		 	if (color==3) color=0; // wrap around if color =3 ->color 0=red, 1 =green, 2 =blue
   		
 
		 	 while (BtnIsPressed(1))	BtnProcessEvents();
		 	}
		 	
		 if (BtnIsPressed(2) ) { //color value increment
			 	color_screen_update =1;
			 	switch (color) {
				 	
				 case red:
				 red_value++;
				 if (red_value==0) red_value =255;
				 				 
				 break;
				 case green:
				  green_value++;
				 if (green_value==0) green_value =255;
				 break;
				 case blue:
				  blue_value++;
				 if (blue_value==0) blue_value =255;
				 break;
				 default:
				 break;
				 				 	
				 }	
			  while (BtnIsPressed(2))	BtnProcessEvents();	
			 	
			 }	
		 	
		 if (BtnIsPressed(3) ) { //color value decrement
			 	color_screen_update=1;
			 	switch (color) {
				 	
				 case red:
				 
				 if (red_value==0) red_value =0;
				 else
				 red_value--;
				 				 
				 break;
				 case green:
				 
				 if (green_value==0) green_value =0;
				 else
				 green_value--;
				 break;
				 case blue:
				
				 if (blue_value==0) blue_value =0;
				 else
				 blue_value--;
				 break;
				 default:
				 break;
				 				 	
				 }	
			 	
			  while (BtnIsPressed(3))	BtnProcessEvents();	
			 }	
		 	
		 	
		 	
		 	
		 	
		 }	
	 
	 
	 
	 
	} 
	
	
	
	
	
	
	
}	





//assumes intadc(0xFDFF) already done to set channel AN9 pin 26 RB15 I/o exp bus pin 10***thk modifed
// intadc(0xFFEF) for an4 rb2 pin 6
//modifed for temperature display
void showADC(void) {
		//clear_display();
			move_FirstLine();
   	update_Display(screenADCA, sizeof screenADCA-1);
   	move_SecondLine();
   	update_Display(screenADCB, sizeof screenADCB-1);
	 binary_temp =0;
	 int voltage =0;
	 z=0;
	 for (z =0; z<64 ; z++) {
	delay_5msec();
	   adcvalue = readADC(4);    //select input channel AN9 on RB15 I/O pin 1088modified for an4 rb2 pin 6
   	binary_temp =binary_temp+adcvalue;
          }   
    
      binary_temp =binary_temp>>6;
      	voltage =0;
  	for( z =0; z<binary_temp; z++)  //count
   	{  voltage =voltage + 32;
	   }	 
       voltage = voltage/100;   // display 2xADRESH for thermo vlaue
		binary_to_ASCIIconvert(voltage);
		binary_temp =0;
	

  // 	count[0]=bcd1000; //temp
  // 	count[1]=bcd100;
   	count[2]=bcdtens;
   	count[3]=bcdunits;
//   	voltage =0;
//   	for( i =0; i<adcvalue; i++)  //count
//   	{  voltage =voltage + 3;
//	   }	 
//   voltage =(voltage)/10;
//   	 binary_to_ASCIIconvert(voltage);
//   	 voltage =0;
//   	count[6]= bcd100;
//   	count[8]=bcdtens;
	 move_ThirdLine();
    update_Display(count, sizeof count);
	}	

void fig_bit(unsigned char leds ) {  
unsigned char tempz=0;
	tempz = leds & 0x01;
	if (tempz==1 ) { //rb2 pin 1
	LATBbits.LATB2 =1;
	}
	else{
	LATBbits.LATB2 =0;
	}
		tempz = leds& 0x02;
		
	if (tempz>=1 ) {//rb3 pin2
	LATBbits.LATB3 =1;
	}
	else {
	LATBbits.LATB3 =0;
	}
		tempz = leds& 0x04;
	if (tempz>=1 ) {// rb5 pin3
	LATBbits.LATB5 =1;
	}
	else {
	LATBbits.LATB5 =0;
	}
		tempz = leds& 0x08;
	if (tempz >=1) {//rb7 pin4
	LATBbits.LATB7 =1;
	}
	else {
	LATBbits.LATB7 =0;
	}
		tempz = leds& 0x10;
	if (tempz >=1) {//rb8 pin 5
	LATBbits.LATB8 =1;
	}
	else {
	LATBbits.LATB8 =0;
	}
		tempz = leds& 0x20;
	if (tempz>=1 ) {//rb9 pin 6
	LATBbits.LATB9 =1;
	}
	else {
	LATBbits.LATB9 =0;
	}
		tempz = leds& 0x40;
	if (tempz>=1 ) {//rb12 pin 7
	LATBbits.LATB12 =1;
	}
	else {
	LATBbits.LATB12 =0;
	}
		tempz = leds& 0x80;
	if (tempz>=1 ) {//rb13 pin 8
	LATBbits.LATB13 =1;
	}
	else {
	LATBbits.LATB13 =0;
	}

	
}		
//this sets up I/O expansion bus pins 1-8 as outputs
// and  drives light  patterns to those pins assuming
// leds are in place.
void lightdemo(int control) {
	//setup I/O
	unsigned char direction =1;
	int h =0;
	light_pattern =0;
	TRISBbits.TRISB2 =0;  // RB2 pin 1
	LATBbits.LATB2 =0;
	TRISBbits.TRISB3 =0;  // RB3 pin 2
		LATBbits.LATB3 =0;
	TRISBbits.TRISB5 =0;  // RB5 pin 3
		LATBbits.LATB5 =0;
	TRISBbits.TRISB7 =0;  // RB7 pin 4
		LATBbits.LATB7 =0;
	TRISBbits.TRISB8 =0;  // RB8 pin 5
		LATBbits.LATB8 =0;
	TRISBbits.TRISB9 =0;  // RB9 pin 6
		LATBbits.LATB9 =0;
	TRISBbits.TRISB12 =0;  // RB12 pin 7
		LATBbits.LATB12 =0;
	TRISBbits.TRISB13 =0;  // RB13 pin 8
		LATBbits.LATB13 =0;
		light_pattern =0x80;
		int max = 9;
			 if (control ==1 )  
	max = 9;

	for (h=1; h< max_led; h++)
	{
	fig_bit(light_pattern);
	  _C =0;
	  if (direction ==1) {
		  //shift right
          light_pattern =light_pattern >>1;
          if (_C ==1 ) {
	        light_pattern =0x01;
	        _C=0;  
	        direction =0;
	    	       }
	  } 
	   if (direction ==0) {
		  //shift left
          light_pattern =light_pattern <<1;
          if (_C ==1 ) {
	        light_pattern =0x80;
	        _C=0;  
	        direction =1;
	    	       }
	  } 
	 if (control ==0 )  
//	delay_40msec();
 { delay_5msec();
delay_5msec();
delay_5msec();
}
	else
	{
		int z =0;
	for(z =0; z< adcvalue; z++) 	
delay_30us();
delay_30us();
delay_30us();
delay_30us();
delay_30us();

	}	


	}
	light_pattern =0; //reset leds on exit
	fig_bit(light_pattern);
	
}
	

//translate temp bit pattern into Proper I/O expansion bit setting

void binary_to_ASCIIconvert( int n) {
bcd1000=0x00;
bcd100 =0x00;
bcdtens =0x00;
bcdunits =0x00;
while (n>=1000) {
n = n-1000;
bcd1000 =bcd1000+1;
}
while (n>=100) {
n = n-100;
bcd100 =bcd100+1;
}
while (n>=10) {
n = n-10;
bcdtens =bcdtens+1;
}
//while (n>0) {
//n = n-1;
//bcdunits =bcdunits+1;
//}
 bcdunits =n;
bcd1000 =bcd1000+0x30;
bcd100 =bcd100+0x30;
bcdtens =bcdtens+0x30;
bcdunits =bcdunits+0x30;
}

	
//RX U2 interrupt
void __attribute__((interrupt, no_auto_psv)) _U2RXInterrupt(void)
{
	
 

		rxchar =  (char) (U2RXREG & 0x00ff);
	
	
		got_rx =1;
		// Clear the UART RX interrupt flag bit
        IFS1bits.U2RXIF = 0;
      			
	

        
	

}
void RGB_Screen_Update( void) {
	//this should update the entire lCD screen
	//with appropiate values of color count for red, green and blue values
	 unsigned char address = 0;
	 unsigned char tempx=0;
	clear_display();
	//screen1 'Introducing the 16 bit Experimenter'
   	move_FirstLine();
   	update_Display(screenRGB1, sizeof screenRGB1-1); //write standard text with blanks
  // tempx= ~red_value;
  // 	binary_to_ASCIIconvert( (int)tempx );
  binary_to_ASCIIconvert( 255-red_value );
   	color_count[0] = bcd100 ;		//move bcd to color count
	color_count [1] =bcdtens;
	color_count [2]= bcdunits ;
   	address =0x80+7;
   	LCDWrite(address,0); //point to data field of red count
   	update_Display(color_count, 3);
   	move_SecondLine();
   	update_Display(screenRGB2, sizeof screenRGB2-1);
// tempx= ~green_value;
//	
//	binary_to_ASCIIconvert((int)tempx );
binary_to_ASCIIconvert(255-green_value );
	color_count[0] = bcd100 ;
	color_count [1] =bcdtens;
	color_count [2]= bcdunits ;
	address =0x80+16+7;
   	LCDWrite(address,0); //point to data field of green count
   		update_Display(color_count, 3);	
    move_ThirdLine();
	update_Display(screenRGB3, sizeof screenRGB3-1);
//	 tempx= ~blue_value;
//	binary_to_ASCIIconvert((int) tempx);
binary_to_ASCIIconvert(255-blue_value);
	color_count[0] = bcd100 ;
	color_count [1] =bcdtens;
	color_count [2]= bcdunits ;
	address =0x80+32+7;
   	LCDWrite(address,0); //point to data field of blue count
   	update_Display(color_count, 3);
	switch (color) {  //indicate which color is active
				 case red:
					move_FirstLine();
					color_count [3]= '<' ; // ascii <
   					address =0x80+11;
   					LCDWrite(address,0); //point to data field of red count
   					update_Display(&color_count[3], 1);
				 break;
				 case green:
				 	move_SecondLine();
					color_count [3]= '<' ; // ascii <
   					address =0x80+11+16;
   					LCDWrite(address,0); //point to data field of red count
   					update_Display(&color_count[3], 1);
				 break;
				 case blue:
				 move_ThirdLine();
					color_count [3]= '<' ; // ascii <
   					address =0x80+11+32;
   					LCDWrite(address,0); //point to data field of red count
   					update_Display(&color_count[3], 1);
				 break;
				 default:
				 break;
				 				 	
				 }	
	
	
	
}	
//this is the major user selected operation for demo selection DEMO
void checkButtons(void){
	delay_40msec();
	QBtnProcessEvents();
		
//		if (BtnIsPressed(3)){ // speed change on rotate LED
//                 	clear_display();  
//                 	 move_FirstLine();
//   					update_Display(screenVRA, sizeof screenVRA-1);
//   					move_SecondLine();
//   					update_Display(screenVRB, sizeof screenVRB-1);
//   						move_ThirdLine();
//   					update_Display(screenVRC, sizeof screenVRC-1);    
//                  	adcvalue = readADC(9);    //select input channel AN9 on RB15 I/O pin 10
//                  
//                  		do 
//   					{
//   					lightdemo(1);   //keep showing light demo while button 3 is depressed
//                    // wait for button released
//                    delay_1us();
//                     QBtnProcessEvents();
//                     	adcvalue = readADC(9); 
//        			} while (BtnIsPressed(3)) ;   
                    
         
 // }                  

			if (AdcFlag==1){   //ADC demo
					clear_display();
				 do 
				 {
				 showADC();		//keep showing ADC demo while button 2 is depressed
				 delay_40msec();
				 QBtnProcessEvents();
				}
				while (AdcFlag==1);
                   
  			} 
                   
//		if (LightShowFlag==1){ // I/O LED demo rotate LED
//		
//					clear_display();
//				    move_FirstLine();
//   					update_Display(screenIOA, sizeof screenIOA-1);
//   					move_SecondLine();
//   					update_Display(screenIOB, sizeof screenIOB-1);
//   						move_ThirdLine();
//   					update_Display(screenIOC, sizeof screenIOC-1);
//   					do 
//   					{
//   					lightdemo(0);   //keep showing light demo while button 3 is depressed
//                    // wait for button released
//                    delay_40msec();
//                     QBtnProcessEvents();
//        			} while (LightShowFlag==1) ;           
//  		}                 
 	if (LightShowFlag==1) {
	 		clear_display();
	 		showRGB();
	 		LightShowFlag=0;
	 	
	 }	
		if (ClockFlag==1){
				clear_display();
					TimerInit();
                     clock(); //call clock and stay in there forever******
                    // wait for button released
                    //while (ClockFlag==1)QBtnProcessEvents();
                    
  }                  
//	

	
	
}
void christmaslights (void) {
	
	//christmas light show
	 TRISBbits.TRISB2 =0;  // RB2 pin 1
	LATBbits.LATB2 =0;
	TRISBbits.TRISB3 =0;  // RB3 pin 2
		LATBbits.LATB3 =0;
	TRISBbits.TRISB5 =0;  // RB5 pin 3
		LATBbits.LATB5 =0;
	TRISBbits.TRISB7 =0;  // RB7 pin 4
		LATBbits.LATB7 =0;
	TRISBbits.TRISB8 =0;  // RB8 pin 5
		LATBbits.LATB8 =0;
	TRISBbits.TRISB9 =0;  // RB9 pin 6
		LATBbits.LATB9 =0;
	TRISBbits.TRISB12 =0;  // RB12 pin 7
		LATBbits.LATB12 =0;
	TRISBbits.TRISB13 =0;  // RB13 pin 8
		LATBbits.LATB13 =0;
			srand(256);
				clear_display();
	//screen1 'Introducing the 16 bit Experimenter'
   	move_FirstLine();
   	update_Display(H1, sizeof H1-1);
   	move_SecondLine();
   	update_Display(H2, sizeof H2-1);
   		move_ThirdLine();
   	update_Display(H3, sizeof H3-1);


}
void updateChristmasdisplay (void) {
			clear_display();
	//screen1 'Introducing the 16 bit Experimenter'
   	move_FirstLine();
   	update_Display(H1, sizeof H1-1);
   	move_SecondLine();
   	update_Display(H2, sizeof H2-1);
   		move_ThirdLine();
   	update_Display(H3, sizeof H3-1);	
	
	
	
	
}	
void playjinglebells(void) {

 int i=0;
//second stanza 
	
	char*chpointer  =&song2[0];
	for ( i=0; i< sizeof song2 -1;i++) {
	if (i==0) {
		clear_display();
		move_FirstLine();
   	update_Display(J1, sizeof J1-1);
			
	}	
	if (i==22) {
			clear_display();
		move_FirstLine();
	
   	update_Display(J2, sizeof J2-1);
			
	}
		if (i==41) {
		clear_display();
		move_FirstLine();
   	update_Display(J3, sizeof J3-1);
			
	}
		if (i==63) {
		clear_display();
		move_FirstLine();
   	update_Display(J5, sizeof J5-1);
			
	}			
					
		
	
 playmusic( *chpointer );
	 chpointer++;
	} 
	
	delay_40msec();
	delay_40msec();
	delay_40msec();
	
}

//***************************************************/
int main (void)
{
	CLKDIVbits.RCDIV = 0; //no clk div stay at 16MIPS

__builtin_write_OSCCONL(OSCCON & 0xbf) ; //clear bit 6.
//input
//	RPINR18bits.U1RXR = 9;	// Make Pin RP9 U1RX
	RPINR19bits.U2RXR = 9;	// Make Pin RP9 U2RX


//output
//	RPOR4bits.RP8R = 3;		// Make Pin RP8 U1TX
	RPOR4bits.RP8R = 5;		// Make Pin RP8 U2TX
RPOR6bits.RP12R  = 18;   //RB12
    // Configure the LED Green Control, pins 6 (RP19) and 8 (RP27), for Output Compare 2 (function 19)
//    RPOR9bits.RP19R  = 19;
//    RPOR13bits.RP27R = 19;
RPOR6bits.RP13R = 19;  //RB13
    // Configure the LED Blue Control, pins 4 (RP21) and 5 (RP26), for Output Compare 3 (function 20)
//    RPOR10bits.RP21R = 20;
//    RPOR13bits.RP26R = 20;
 //RPOR7bits.RP15R = 20;  //RB15   **** modified for tone
 RPOR7bits.RP15R = 18;  //RB15   **** modified for tone
//
	
__builtin_write_OSCCONL(OSCCON | 0x40) ; //set bit 6

 ;
 	//PADCFG1 = 0xFF;			// Make analog pins digital
 

initLCDIo();

LCDInit();
RTCCInit();
BtnInit();
TBannerInit();
 //initADC(0xFDFF);  //make rb15 AN9 an analog input
 //initADC(0xFFEF);  //make rb2  AN4 an analog input
int i=0;
int n=255;
	_T1IP =4;
	_U2RXIP=4;
//	INTCON1bits.NSTDIS =1;
	_IPL =0;
	
	//  init the console serial port 
//	initU2();
	
//enable U2 Rx interrupt
//	_U2RXIF =0;
//	_U2RXIE =1;




	LCDWrite(0x01,0);  ///clear
	move_FirstLine();
	TimerInit();
	// DISPLAY     0x0c	//display on/off --display on, cursor off, cursor blink off
	LCDWrite(0x0C,0);
		clear_display();
		
		
//	do 
//	{
//	showADC();	
//	delay();	
//	} while(1);	
//	clear_display();
//	//screen1 'Introducing the 16 bit Experimenter'
//   	move_FirstLine();
//   	update_Display(screenRGB1, sizeof screenRGB1-1);
//   	move_SecondLine();
//	update_Display(screenRGB2, sizeof screenRGB2-1);	
//    move_ThirdLine();
//	update_Display(screenRGB3, sizeof screenRGB3-1);
	 unsigned char address=0;
// 	RGBTurnOnLED( 255,255,255); //255 is off, 0 is on
// 
//	 blue_value =255;
//	 red_value =255;
//	 green_value =255;
// 	 RGBSetBlue( blue_value ); 
// 	RGBSetGreen( green_value );
//	 RGBSetRed(red_value);
//	 
//	 RGB_Screen_Update();
//	 	move_FirstLine();
//		color_count [3]= '<' ; // ascii <
//   		address =0x80+10;
//   		LCDWrite(address,0); //point to data field of red count
//   		update_Display(color_count[3], 1);
//	
// while(1) {
//	if  (color_screen_update==1) 
//	{
//	 	RGBSetBlue( blue_value ); 
// 		RGBSetGreen( green_value );
//	 	RGBSetRed(red_value);
//	 	RGB_Screen_Update();
//		color_screen_update=0;	
//	}	
//	 if (TimerIsOverflowEvent()) {
//		 	QBtnProcessEvents();
//		 if (BtnIsPressed(1) ) {
//		 	color++;
//		 	color_screen_update=1;
//		 	if (color==3) color=0; // wrap around if color =3 ->color 0=red, 1 =green, 2 =blue
//   		
// 
//		 	 while (BtnIsPressed(1))	BtnProcessEvents();
//		 	}
//		 	
//		 if (BtnIsPressed(2) ) { //color value increment
//			 	color_screen_update =1;
//			 	switch (color) {
//				 	
//				 case red:
//				 red_value++;
//				 if (red_value==0) red_value =255;
//				 				 
//				 break;
//				 case green:
//				  green_value++;
//				 if (green_value==0) green_value =255;
//				 break;
//				 case blue:
//				  blue_value++;
//				 if (blue_value==0) blue_value =255;
//				 break;
//				 default:
//				 break;
//				 				 	
//				 }	
//			  while (BtnIsPressed(2))	BtnProcessEvents();	
//			 	
//			 }	
//		 	
//		 if (BtnIsPressed(3) ) { //color value decrement
//			 	color_screen_update=1;
//			 	switch (color) {
//				 	
//				 case red:
//				 
//				 if (red_value==0) red_value =0;
//				 else
//				 red_value--;
//				 				 
//				 break;
//				 case green:
//				 
//				 if (green_value==0) green_value =0;
//				 else
//				 green_value--;
//				 break;
//				 case blue:
//				
//				 if (blue_value==0) blue_value =0;
//				 else
//				 blue_value--;
//				 break;
//				 default:
//				 break;
//				 				 	
//				 }	
//			 	
//			  while (BtnIsPressed(3))	BtnProcessEvents();	
//			 }	
//		 	
//		 	
//		 	
//		 	
//		 	
//		 }	
//	 
//	 
//	 
//	
//playjinglebells();

//christmas light show
//	 TRISBbits.TRISB2 =0;  // RB2 pin 1
//	LATBbits.LATB2 =0;
//	TRISBbits.TRISB3 =0;  // RB3 pin 2
//		LATBbits.LATB3 =0;
//	TRISBbits.TRISB5 =0;  // RB5 pin 3
//		LATBbits.LATB5 =0;
//	TRISBbits.TRISB7 =0;  // RB7 pin 4
//		LATBbits.LATB7 =0;
//	TRISBbits.TRISB8 =0;  // RB8 pin 5
//		LATBbits.LATB8 =0;
//	TRISBbits.TRISB9 =0;  // RB9 pin 6
//		LATBbits.LATB9 =0;
//	TRISBbits.TRISB12 =0;  // RB12 pin 7
//		LATBbits.LATB12 =0;
//	TRISBbits.TRISB13 =0;  // RB13 pin 8
//		LATBbits.LATB13 =0;
//			srand(256);
//				clear_display();
//	//screen1 'Introducing the 16 bit Experimenter'
//   	move_FirstLine();
//   	update_Display(H1, sizeof H1-1);
//   	move_SecondLine();
//   	update_Display(H2, sizeof H2-1);
//   		move_ThirdLine();
//   	update_Display(H3, sizeof H3-1);
// intializes christmas lights
christmaslights(); 
	srand(256);
unsigned char x =0;
	LATAbits.LATA0 =1;
		TRISAbits.TRISA0=1;
while(1) {

 	fig_bit(srand()*x ); 
 	x++;
 	//delay();
 	delay_40msec();
 	delay_40msec();
	
	
		if (_RA0==0) //is button depressed?
		{
			delay_5msec();
			if ( _RA0==0) {
				TRISAbits.TRISA0=0;	
					fig_bit(0); 
			 playjinglebells();	
			updateChristmasdisplay ();
			//srand(256);
			//	x=0;
		LATAbits.LATA0 =1;
		TRISAbits.TRISA0=1;	
			}	
		}	
	delay_40msec();	
		
	
//	QBtnProcessEvents();
//	if (BtnIsPressed(1) ) {
//                // Change field  
//             playjinglebells();
//                  // TBannerNext();
//                  updateChristmasdisplay ();
//                  	srand(256);
//                  	x=0;
//
//                // wait for button released
//                while (BtnIsPressed(1))	BtnProcessEvents();	
// }  
}              

while(1) { //splash display with built-in demo
	do{
			checkButtons();
	clear_display();
	//screen1 'Introducing the 16 bit Experimenter'
   	move_FirstLine();
   	update_Display(screen1A, sizeof screen1A-1);
   	move_SecondLine();
	update_Display(screen1B, sizeof screen1B-1);	
    move_ThirdLine();
	update_Display(screen1C, sizeof screen1C-1);
	
	big_delay();
	checkButtons();
	clear_display();
	//screen2 'A new solderless breadboard capability'
	move_FirstLine();
   	update_Display(screen2A, sizeof screen2A-1);
   	move_SecondLine();
	update_Display(screen2B, sizeof screen2B-1);	
    move_ThirdLine();
	update_Display(screen2C, sizeof screen2C-1);

	big_delay();
		checkButtons();
	clear_display();
	//screen3 'based upon Microchip's PIC24F technology'
	move_FirstLine();
   	update_Display(screen3A, sizeof screen3A-1);
   	move_SecondLine();
	update_Display(screen3B, sizeof screen3B-1);	
    move_ThirdLine();
	update_Display(screen3C, sizeof screen3C-1);
		
	big_delay();
		checkButtons();
	clear_display();
	//screen4 '3.3V 16MIPS 64KB FLASH 8KB RAM 32KB EEPROM'
	move_FirstLine();
   	update_Display(screen4A, sizeof screen4A-1);
   	move_SecondLine();
	update_Display(screen4B, sizeof screen4B-1);	
    move_ThirdLine();
	update_Display(screen4C, sizeof screen4C-1);
	
	big_delay();
		checkButtons();
	clear_display();
	//screen5 '5v logic compatibility'
	move_FirstLine();
   	update_Display(screen5A, sizeof screen5A-1);
   	move_SecondLine();
	update_Display(screen5B, sizeof screen5B-1);	
    move_ThirdLine();
	update_Display(screen5C, sizeof screen5C-1);

	big_delay();
		checkButtons();
	clear_display();
	//screen6 'perpherials'
	move_FirstLine();
   	update_Display(screen6A, sizeof screen6A-1);
   	move_SecondLine();
	update_Display(screen6B, sizeof screen6B-1);	
    move_ThirdLine();
	update_Display(screen6C, sizeof screen6C-1);

	big_delay();
		checkButtons();
	clear_display();
	//screen6A 'perpherials'
	move_FirstLine();
   	update_Display(screen6AA, sizeof screen6AA-1);
   	move_SecondLine();
	update_Display(screen6AB, sizeof screen6AB-1);	
    move_ThirdLine();
	update_Display(screen6AC, sizeof screen6AC-1);

	big_delay();
		checkButtons();
	clear_display();
	//screen7 
	move_FirstLine();
   	update_Display(screen7A, sizeof screen7A-1);
   	move_SecondLine();
	update_Display(screen7B, sizeof screen7B-1);	
    move_ThirdLine();
	update_Display(screen7C, sizeof screen7C-1);
	
	big_delay();
	checkButtons();
	clear_display();
	//screen8 
	move_FirstLine();
   	update_Display(screen8A, sizeof screen8A-1);
   	move_SecondLine();
	update_Display(screen8B, sizeof screen8B-1);	
    move_ThirdLine();
	update_Display(screen8C, sizeof screen8C-1);
	
		big_delay();
			checkButtons();
	clear_display();
	//screen9 
	move_FirstLine();
   	update_Display(screen9A, sizeof screen9A-1);
   	move_SecondLine();
	update_Display(screen9B, sizeof screen9B-1);	
    move_ThirdLine();
	update_Display(screen9C, sizeof screen9C-1);

	big_delay();
		checkButtons();
	clear_display();
	//screen10 
	move_FirstLine();
   	update_Display(screen10A, sizeof screen10A-1);
   	move_SecondLine();
	update_Display(screen10B, sizeof screen10B-1);	
    move_ThirdLine();
	update_Display(screen10C, sizeof screen10C-1);

		big_delay();
//	delay();
//	delay();
//		lightdemo();
	checkButtons();
	clear_display();
	//screen11
	move_FirstLine();
   	update_Display(screen11A, sizeof screen11A-1);
   	move_SecondLine();
	update_Display(screen11B, sizeof screen11B-1);	
    move_ThirdLine();
	update_Display(screen11C, sizeof screen11C-1);

		big_delay();
	}

	while(1);   //pause to establish demo code

}	



};	


//end of code
