//*******************************************************************************/
#include "p24fj64ga002.h"
/******************************************************************************

* File Name:       tone.c
* Dependencies:    None
* Processor:       PIC24FJ64GA002
* Compiler:        C30 v3.02c
* Company:         Microchip Technology, Inc.


Author          Date    Comments
--------------------------------------------------------------------------------
thk         10/24/09 First release
----------------------------------------------------------------------------
These are note definitions for Timer2 PR2 with Timer Prescale of 1 @ 16 MHZ TCY
PPS must of be done ahead of hand to enable OC1 to pin10 of Experimenter I/O bus
which is AN9/CN11/RB15/RP15 as follows 
RPOR7bits.RP15 =18;
//notes values and designators
#define Cnote 61068
#define Dnote 54421
#define Enote 48484
#define Fnote 45844
#define Gnote 40815
#define Anote 36363
#define Bnote 32388
#define LowCnote 30592
 
*/
#include "delay.h"
#include "tone.h"

//this function playtone or no tone based upon control  script designators
//controls are -,c,d,e,f,g,a,b,l  l =lowCNote

void playmusic( char control) {
	
	switch (control) 
	{
	Toneoff();
	case 'c' :
	ToneOn(Cnote);
	break;
	case 'd' :
	ToneOn(Dnote);
	break;
	case 'e' :
	ToneOn(Enote);
	break;
	case 'f' :
	ToneOn(Fnote);
	break;
	case 'g' :
	ToneOn(Gnote);
	break;
	case 'a' :
	ToneOn(Anote);
	break;	
	case 'b' :
	ToneOn(Bnote);
	break;
	case 'l' :  //low C
	ToneOn(LowCnote);
	break;
	case '-' :  //pause
	break;
	default:
	break;
	}	

delay_40msec();
delay_40msec();
//delay_40msec();
//delay_40msec();
//delay_5msec();
delay_5msec();
delay_5msec();
	ToneOff();	
		
	
	
	
	
} 
	
	
	
	



void ToneOn ( unsigned int note) {
	T2CONbits.TON =0;		//timer 2 off
	OC1CON = 0x0000;		// pwm off
	T2CON =0x0000 ;  //timer 2 16 bit mode, prescale 1:1 and off
	PR2 = note; 	// set pr to note vlaue for PWM period
	OC1R = note/2;
	OC1RS = note/2 ; //set PWM duty cycle to 1/2  period

	OC1CON = 0x0006	; //set OC1 to PWM mode no fault
	T2CONbits.TON =1;	//turn on timer
	
	
}

void ToneOff () {
	
	T2CONbits.TON =0;		//timer 2 off
	OC1CON = 0x0000;		// pwm off
	
	
}		

						